Summary: The Linux kernel (the core of the Linux operating system)

# We do not want -debuginfo package
%define debug_package %{nil}

# normal/debug/debuginfo
%define buildnormal 1
%define builddebug 0
%define builddebuginfo 0

# kernels we want to build
%define buildup 1
%define buildsmp 1
%define buildenterprise 1
%define buildentnosplit 0

# versions
%define kversion 2.6.18
%define krelease 028stab053
%define ksubrelease 14

%define rpmversion %{kversion}
%define release ovz%{krelease}.%{ksubrelease}
%define make_target bzImage
%define kernel_image x86

%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}

# groups of related archs
%define all_x86 i586 i686

# Override generic defaults with per-arch defaults 

# Second, per-architecture exclusions (ifarch)

%ifarch %{all_x86}
%define all_arch_configs $RPM_SOURCE_DIR/kernel-%{kversion}-i?86*.config.ovz
%define image_install_path boot
%endif

%ifarch x86_64
%define all_arch_configs $RPM_SOURCE_DIR/kernel-%{kversion}-x86_64*.config.ovz
%define buildenterprise 0
%define buildentnosplit 0
%define image_install_path boot
%endif

%ifarch ia64
%define all_arch_configs $RPM_SOURCE_DIR/kernel-%{kversion}-ia64.config.ovz
%define buildsmp 0
%define buildenterprise 0
%define buildentnosplit 0
%define builddebug 0
%define image_install_path boot/efi/EFI/redhat
%define make_target compressed
%define kernel_image vmlinux.gz
%endif

%ifarch ppc64
%define all_arch_configs $RPM_SOURCE_DIR/kernel-%{kversion}-ppc64.config.ovz
%define buildsmp 0
%define buildenterprise 0
%define buildentnosplit 0
%define image_install_path boot
%define make_target vmlinux
%define kernel_image vmlinux
%endif

%define _unpackaged_files_terminate_build 0

#
# Three sets of minimum package version requirements in the form of Conflicts:
# to versions below the minimum
#

#
# First the general kernel 2.6 required versions as per
# Documentation/Changes
#
%define kernel_dot_org_conflicts  ppp <= 2.3.15, pcmcia-cs <= 3.1.20, isdn4k-utils <= 3.0, mount < 2.10r-5, nfs-utils < 1.0.3, e2fsprogs < 1.29, util-linux < 2.10, jfsutils < 1.0.14, reiserfsprogs < 3.6.3, xfsprogs < 2.1.0, procps < 2.0.9, oprofile < 0.5.3

# 
# Then a series of requirements that are distribution specific, either 
# because we add patches for something, or the older versions have 
# problems with the newer kernel or lack certain things that make 
# integration in the distro harder than needed.
#
%define package_conflicts  cipe < 1.4.5, tux < 2.1.0, kudzu <= 0.92, initscripts < 7.23, dev < 3.2-7, iptables < 1.2.5-3, bcm5820 < 1.81, nvidia-rh72 <= 1.0

#
# Several packages had bugs in them that became obvious when the NPTL
# threading code got integrated. 
#
%define nptl_conflicts SysVinit < 2.84-13, pam < 0.75-48, vixie-cron < 3.0.1-73, privoxy < 3.0.0-8, spamassassin < 2.44-4.8.x,  cups < 1.1.17-13

#
# Packages that need to be installed before the kernel is, because the %post
# scripts use them.
#
%define kernel_prereq  fileutils, module-init-tools, initscripts >= 5.83, mkinitrd >= 3.5.5

Name: kernel
Group: System Environment/Kernel
License: GPLv2
Version: %{rpmversion}
Release: %{release}
ExclusiveArch: noarch %{all_x86} x86_64 ia64 ppc64
ExclusiveOS: Linux
Provides: kernel = %{version}
Provides: kernel-drm = 4.3.0
Provides: vzkernel = %{KVERREL}
Provides: vzquotamod
Prereq: %{kernel_prereq}
Conflicts: %{kernel_dot_org_conflicts}
Conflicts: %{package_conflicts}
Conflicts: %{nptl_conflicts}
# We can't let RPM do the dependencies automatic because it'll then pick up
# a correct but undesirable perl dependency from the module headers which
# isn't required for the kernel proper to function
AutoReqProv: no

#
# List the packages used during the kernel build
#
BuildPreReq: module-init-tools, patch >= 2.5.4, bash >= 2.03, sh-utils, tar
BuildPreReq: bzip2, findutils, gzip, m4, perl, make >= 3.78, gnupg
BuildRequires: gcc >= 2.96-98, binutils >= 2.12
BuildConflicts: rhbuildsys(DiskFree) < 500Mb

Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-%{kversion}.tar.bz2

Source20: kernel-%{kversion}-i686.config.ovz
Source21: kernel-%{kversion}-i686-smp.config.ovz
Source22: kernel-%{kversion}-i686-enterprise.config.ovz
Source23: kernel-%{kversion}-x86_64.config.ovz
Source24: kernel-%{kversion}-x86_64-smp.config.ovz
Source25: kernel-%{kversion}-ia64.config.ovz
Source26: kernel-%{kversion}-ppc64.config.ovz

%if %{!?_without_source:0}%{?_without_source:1}
NoSource: 0
%endif

# ----------------------------------------------------------------------------
# List of patches
# ----------------------------------------------------------------------------
Patch1: linux-2.6.0-nonintconfig.patch
Patch100: patch-%{krelease}-core

#---1000------ IA64 --------------------------

#---2000------ x86_64 ------------------------

#---5000------ driver patches ----------------
Patch2001: linux-2.6.17-aic94xx-1.0.2.patch

Patch2101: linux-2.6.8.1-drbd-0.7.19.patch
Patch2102: linux-2.6.8.1-drbd-0.7.19-0.7.20.patch
Patch2103: linux-2.6.9-drbd-0.7.20-0.7.22.patch
Patch2104: linux-2.6.18-drbd-0.7.22-0.8.0.patch
Patch2105: linux-2.6.18-drbd-8.0.0-8.0.2.patch
Patch2106: linux-2.6.18-drbd-8.0.2-8.0.3.patch
Patch2107: linux-2.6.18-drbd-8.0.3-8.0.4.patch
Patch2108: linux-2.6.18-drbd-8.0.4-8.0.5.patch
Patch2109: linux-2.6.18-drbd-8.0.5-8.0.6.patch
Patch2110: linux-2.6.18-drbd-8.0.6-8.0.7.patch

Patch9990: diff-fairsched-fsch_timeslice-20070107
Patch9991: diff-security-dir-truncate-20080114
Patch9992: diff-ms-splice-access-20080211

Patch9993: linux-2.6-fs-sysfs-store-inode-nrs-in-s_ino.patch
Patch9994: linux-2.6-fs-sysfs-fix-condition-check-in-sysfs_drop_dentry.patch
Patch9995: linux-2.6-fs-sysfs-fix-race-condition-around-sd-s_dentry.patch
Patch9996: linux-2.6-ia64-remove-stack-hard-limit.patch
Patch9997: linux-2.6-fs-core-dump-file-ownership.patch
Patch9998: linux-2.6-x86_64-fix-race-conditions-in-setup_apic_timer.patch
Patch9999: linux-2.6-fs-cifs-buffer-overflow-due-to-corrupt-response.patch
Patch10000: linux-2.6-misc-denial-of-service-with-wedged-processes.patch
Patch10001: linux-2.6-mm-hugepages-leak-due-to-pagetable-page-sharing.patch
Patch10002: linux-2.6-isdn-fix-possible-isdn_net-buffer-overflows.patch
Patch10003: linux-2.6-isdn-i4l-fix-memory-overruns.patch
Patch10004: linux-2.6-video-neofb-avoid-overwriting-fb_info-fields.patch
Patch10005: linux-2.6-x86-clear-df-flag-for-signal-handlers.patch
Patch10006: linux-2.6-fs-fix-race-condition-in-dnotify.patch
Patch10007: diff-locks-fix-smp-ordering-hole-in-fcntl-setlk
Patch10008: diff-fairsched-load-balance-09012008
Patch10009: diff-fix-cpufreq-ondemand-20080220
Patch10010: diff-ve-nf-nat-targets-init-20080228-3
Patch10011: diff-ve-net-call-ip6frag-cleanup-20080504
Patch10012: diff-ve-ipv6-ifdown-20080318
Patch10013: diff-ms-ipv6-anycast-refcnt-20070914
Patch10014: diff-ve-net-leak-netdevice
Patch10015: linux-2.6-misc-fix-range-check-in-fault-handlers-with-mremap.patch

# ----------------------------------------------------------------------------

BuildRoot: %{_tmppath}/kernel-%{KVERREL}-root

%description 
This package contains the OpenVZ kernel. This is the Linux kernel with added
virtualization functionality.

%package debug
Summary: The Linux kernel compiled with debug parameters

Group: System Environment/Kernel
Provides: kernel = %{version}
Provides: kernel-drm = 4.3.0
Provides: vzkernel = %{KVERREL}
Provides: vzquotamod
Prereq: %{kernel_prereq}
Conflicts: %{kernel_dot_org_conflicts}
Conflicts: %{package_conflicts}
Conflicts: %{nptl_conflicts}
AutoReqProv: no

%description debug
Debug kernel

%package smp
Summary: The Linux kernel compiled for SMP machines.

Group: System Environment/Kernel
Provides: kernel = %{version}
Provides: kernel-drm = 4.3.0
Provides: vzkernel = %{KVERREL}
Provides: vzquotamod
Prereq: %{kernel_prereq}
Conflicts: %{kernel_dot_org_conflicts}
Conflicts: %{package_conflicts}
Conflicts: %{nptl_conflicts}
AutoReqProv: no

%description smp
This package includes a SMP version of the OpenVZ kernel. Install the
ovzkernel-smp package if your machine uses two or more CPUs or CPUs with
hyperthreading technology.


%package smp-debug
Summary: The Linux kernel compiled with debug parameters

Group: System Environment/Kernel
Provides: kernel = %{version}
Provides: kernel-drm = 4.3.0
Provides: vzkernel = %{KVERREL}
Provides: vzquotamod
Prereq: %{kernel_prereq}
Conflicts: %{kernel_dot_org_conflicts}
Conflicts: %{package_conflicts}
Conflicts: %{nptl_conflicts}
AutoReqProv: no

%description smp-debug
Debug kernel

%package enterprise
Summary: The Linux kernel compiled for SMP enterprise machines.

Group: System Environment/Kernel
Provides: kernel = %{version}
Provides: kernel-drm = 4.3.0
Provides: vzkernel = %{KVERREL}
Provides: vzquotamod
Prereq: %{kernel_prereq}
Conflicts: %{kernel_dot_org_conflicts}
Conflicts: %{package_conflicts}
Conflicts: %{nptl_conflicts}
AutoReqProv: no

%description enterprise
This package includes a SMP enterprise version of the OpenVZ kernel. Install
the ovzkernel-enterprise package if your machine uses two or more CPUs
(or CPUs with hyperthreading technology) and have more than 4GB RAM.

%package enterprise-debug
Summary: The Linux kernel compiled with debug parameters

Group: System Environment/Kernel
Provides: kernel = %{version}
Provides: kernel-drm = 4.3.0
Provides: vzkernel = %{KVERREL}
Provides: vzquotamod
Prereq: %{kernel_prereq}
Conflicts: %{kernel_dot_org_conflicts}
Conflicts: %{package_conflicts}
Conflicts: %{nptl_conflicts}
AutoReqProv: no

%description enterprise-debug
Debug kernel

%package entnosplit
Summary: The Linux kernel compiled for SMP hugemem machines without 4GB split.

Group: System Environment/Kernel
Provides: kernel = %{version}
Provides: kernel-drm = 4.3.0
Provides: vzkernel = %{KVERREL}
Provides: vzquotamod
Prereq: %{kernel_prereq}
Conflicts: %{kernel_dot_org_conflicts}
Conflicts: %{package_conflicts}
Conflicts: %{nptl_conflicts}
AutoReqProv: no

%description entnosplit
This package includes a SMP hugemem version of the OpenVZ kernel without
4GB split.

%package entnosplit-debug
Summary: The Linux kernel compiled with debug parameters

Group: System Environment/Kernel
Provides: kernel = %{version}
Provides: kernel-drm = 4.3.0
Provides: vzkernel = %{KVERREL}
Provides: vzquotamod
Prereq: %{kernel_prereq}
Conflicts: %{kernel_dot_org_conflicts}
Conflicts: %{package_conflicts}
Conflicts: %{nptl_conflicts}
AutoReqProv: no

%description entnosplit-debug
Debug kernel

# ----------------------------------------------------------------------------
# prepare
# ----------------------------------------------------------------------------
%prep

%setup -q -n %{name}-%{version} -c
cd linux-%{kversion}

# ----------------------------------------------------------------------------
# applying patches
# ----------------------------------------------------------------------------

%patch1 -p1

%patch100 -p1

%patch2001 -p1
%patch2101 -p1
%patch2102 -p1
%patch2103 -p1
%patch2104 -p1
%patch2105 -p1
%patch2106 -p1
%patch2107 -p1
%patch2108 -p1
%patch2109 -p1
%patch2110 -p1

%patch9990 -p1
%patch9991 -p1
%patch9992 -p1

%patch9993 -p1
%patch9994 -p1
%patch9995 -p1
%patch9996 -p1
%patch9997 -p1
%patch9998 -p1
%patch9999 -p1
%patch10000 -p1
%patch10001 -p1
%patch10002 -p1
%patch10003 -p1
%patch10004 -p1
%patch10005 -p1
%patch10006 -p1
%patch10007 -p1
%patch10008 -p1
%patch10009 -p1
%patch10010 -p1
%patch10011 -p1
%patch10012 -p1
%patch10013 -p1
%patch10014 -p1
%patch10015 -p1

# ----------------------------------------------------------------------------

mkdir configs

cp -fv %{all_arch_configs} .


# now run oldconfig over all the config files
for i in *.config* 
do 
	mv $i .config
	arch=`echo $i | cut -d"-" -f3 | cut -d"." -f1 | sed -e s/i.86/i386/ \
		-e s/s390x/s390/ -e s/ppc.*/powerpc/`
	make ARCH=$arch nonint_oldconfig > /dev/null
	cp .config configs/$i
done

# get rid of unwanted files resulting from patch fuzz
find . -name "*.orig" -exec rm -fv {} \;
find . -name "*~" -exec rm -fv {} \;

# ----------------------------------------------------------------------------
# build
# ----------------------------------------------------------------------------
%build

cd linux-%{kversion}


MakeDebugInfoConfig() {
	sed -i -e "s/.*\(CONFIG_DEBUG_INFO\).*/\1=y/" .config
}

MakeDebugConfig() {
	sed -i                                                  \
		-e "s/.*\(CONFIG_DEBUG_SLAB\>\).*/\1=y/"              \
		-e "s/.*\(CONFIG_DEBUG_SPINLOCK\>\).*/\1=y/"          \
		-e "s/.*\(CONFIG_DEBUG_MUTEXES\>\).*/\1=y/"           \
		-e "s/.*\(CONFIG_DEBUG_RWSEMS\>\).*/\1=y/"            \
		-e "s/.*\(CONFIG_DEBUG_LOCK_ALLOC\>\).*/\1=y/"        \
		-e "s/.*\(CONFIG_PROVE_LOCKING\>\).*/\1=y/"           \
		-e "s/.*\(CONFIG_DEBUG_SPINLOCK_SLEEP\>\).*/\1=y/"    \
	.config
	echo "CONFIG_DEBUG_SLAB_LEAK=y" >> .config
	echo "# CONFIG_DEBUG_LOCKDEP is not set" >> .config
}

BuildKernel() {
    MakeTarget=$1
    KernelImage=$2
    Flavour=$3
    Debug=$4
    SUFF=""
    FULLSUFF=""

    [ -z "$Flavour" ] || SUFF="-${Flavour}"
    FULLSUFF=$SUFF
    [ -z "$Debug" ] || FULLSUFF="${FULLSUFF}-${Debug}"

    # Pick the right config file for the kernel we're building
    Config=kernel-%{kversion}-%{_target_cpu}${SUFF}.config.ovz
    KernelVer=%{version}-%{release}${FULLSUFF}
    perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}${FULLSUFF}/" Makefile

    echo BUILDING A KERNEL FOR $Flavour $Debug %{_target_cpu}...

    # and now to start the build process

    make -s mrproper
    cp configs/$Config .config
    arch=`echo $Config | cut -d"-" -f3 | cut -d"." -f1 | sed -e s/i.86/i386/ \
		-e s/s390x/s390/ -e s/ppc.*/powerpc/`
    [ -n "$Debug" ] && MakeDebugConfig
%if %{builddebuginfo}
    MakeDebugInfoConfig
%endif

    make ARCH=${arch} -s nonint_oldconfig > /dev/null
    make -s include/linux/version.h 

    make ARCH=${arch} -s %{?_smp_mflags} $MakeTarget
    make ARCH=${arch} -s %{?_smp_mflags} modules || exit 1
    
    # Start installing the results

    if [ "$KernelImage" = "x86" ]; then
       KernelImage=arch/$arch/boot/bzImage
    fi
    mkdir -p $RPM_BUILD_ROOT/usr/lib/debug/boot
    mkdir -p $RPM_BUILD_ROOT/%{image_install_path}
    install -m 644 System.map $RPM_BUILD_ROOT/usr/lib/debug/boot/System.map-$KernelVer
    install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
    cp $KernelImage $RPM_BUILD_ROOT/%{image_install_path}/vmlinuz-$KernelVer
# We do not want vmlinux for ppc64, since it is the same file as vmlinuz above
%ifnarch ppc64
    cp vmlinux $RPM_BUILD_ROOT/%{image_install_path}/vmlinux-$KernelVer
%endif

    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer
    make -s INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
 
    # And save the headers/makefiles etc for building modules against
    #
    # This all looks scary, but the end result is supposed to be:
    # * all arch relevant include/ files
    # * all Makefile/Kconfig files
    # * all script/ files 

    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/source
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    (cd $RPM_BUILD_ROOT/lib/modules/$KernelVer ; ln -s build source)
    # first copy everything
    cp --parents `find  -type f -name "Makefile*" -o -name "Kconfig*"` $RPM_BUILD_ROOT/lib/modules/$KernelVer/build 
    cp Module.symvers $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    # then drop all but the needed Makefiles/Kconfig files
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/Documentation
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    cp arch/%{_arch}/kernel/asm-offsets.s $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/arch/%{_arch}/kernel || :
    cp .config $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    cp -a scripts $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    cp -a arch/%{_arch}/scripts $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/arch/%{_arch} || :
    cp -a arch/%{_arch}/*lds $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/arch/%{_arch}/ || :
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts/*.o
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts/*/*.o
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    cd include
    cp -a acpi config linux math-emu media net pcmcia rxrpc scsi sound video asm asm-generic ub $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    cp -a `readlink asm` $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    # Make sure the Makefile and version.h have a matching timestamp so that
    # external modules can be built
    touch -r $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/Makefile $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include/linux/version.h
    touch -r $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/.config $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include/linux/autoconf.h
    cd .. 

    #
    # save the vmlinux file for kernel debugging into the kernel-debuginfo rpm
    #
    mkdir -p $RPM_BUILD_ROOT/usr/lib/debug/lib/modules/$KernelVer
    cp vmlinux $RPM_BUILD_ROOT/usr/lib/debug/lib/modules/$KernelVer

    # mark modules executable so that strip-to-file can strip them
    find $RPM_BUILD_ROOT/lib/modules/$KernelVer -name "*.ko" -type f  | xargs chmod u+x
#    cp -r $RPM_BUILD_ROOT/lib/modules/$KernelVer/kernel $RPM_BUILD_ROOT/usr/lib/debug/lib/modules/$KernelVer

    # detect missing or incorrect license tags
    for i in `find $RPM_BUILD_ROOT/lib/modules/$KernelVer -name "*.ko" ` ; do echo -n "$i " ; /sbin/modinfo -l $i >> modinfo ; done
    cat modinfo | grep -v "^GPL" | grep -v "^Dual BSD/GPL" | grep -v "^Dual MPL/GPL" | grep -v "^GPL and additional rights" | grep -v "^GPL v2" && exit 1 
    rm -f modinfo
    # remove files that will be auto generated by depmod at rpm -i time
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/modules.*

}

XBuildKernel() {
  # build normal kernel
%if %{buildnormal}
  BuildKernel $1 $2 $3
%endif
%if %{builddebug}
  BuildKernel "$1" "$2" "$3" "debug"
%endif
}

###
# DO it...
###

# prepare directories
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/boot

%if %{buildup}
XBuildKernel %make_target %kernel_image
%endif

%if %{buildsmp}
XBuildKernel %make_target %kernel_image smp
%endif

%if %{buildenterprise}
XBuildKernel %make_target %kernel_image enterprise
%endif

%if %{buildentnosplit}
XBuildKernel %make_target %kernel_image entnosplit
%endif

###
### install
###

%install

cd linux-%{kversion}

# architectures that don't get kernel-source (i586/i686/athlon) dont need
# much of an install because the build phase already copied the needed files

###
### clean
###

%clean
rm -rf $RPM_BUILD_ROOT

###
### scripts
###

# load the loop module for upgrades...in case the old modules get removed we have
# loopback in the kernel so that mkinitrd will work.
%pre 
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre debug
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre smp
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre smp-debug
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre enterprise
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre enterprise-debug
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre entnosplit
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre entnosplit-debug
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%post 
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}

%post debug
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}-debug

%post smp
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}-smp

%post smp-debug
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}-smp-debug

%post enterprise
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}-enterprise

%post enterprise-debug
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}-enterprise-debug

%post entnosplit
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}-entnosplit

%post entnosplit-debug
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}-entnosplit-debug

%preun 
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}

%preun debug
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}-debug

%preun smp
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}-smp

%preun smp-debug
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}-smp-debug

%preun enterprise
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}-enterprise

%preun enterprise-debug
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}-enterprise-debug

%preun entnosplit
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}-entnosplit

%preun entnosplit-debug
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}-entnosplit-debug


###
### file lists
###

%if %{buildup} && %{buildnormal}
%files 
%defattr(-,root,root)
/%{image_install_path}/vmlinuz-%{KVERREL}
%ifnarch ppc64
/%{image_install_path}/vmlinux-%{KVERREL}
%endif
/boot/System.map-%{KVERREL}
%dir /lib/modules/%{KVERREL}
/lib/modules/%{KVERREL}/kernel
%verify(not mtime) /lib/modules/%{KVERREL}/build
%endif

%if %{buildup} && %{builddebug}
%files debug
%defattr(-,root,root)
/%{image_install_path}/vmlinuz-%{KVERREL}-debug
%ifnarch ppc64
/%{image_install_path}/vmlinux-%{KVERREL}-debug
%endif
/boot/System.map-%{KVERREL}-debug
%dir /lib/modules/%{KVERREL}-debug
/lib/modules/%{KVERREL}-debug/kernel
%verify(not mtime) /lib/modules/%{KVERREL}-debug/build
%endif

### ------------------ SMP -----------------------

%if %{buildsmp} && %{buildnormal}
%files smp
%defattr(-,root,root)
/%{image_install_path}/vmlinuz-%{KVERREL}-smp
%ifnarch ppc64
/%{image_install_path}/vmlinux-%{KVERREL}-smp
%endif
/boot/System.map-%{KVERREL}-smp
%dir /lib/modules/%{KVERREL}-smp
/lib/modules/%{KVERREL}-smp/kernel
%verify(not mtime) /lib/modules/%{KVERREL}-smp/build
%endif

%if %{buildsmp} && %{builddebug}
%files smp-debug
%defattr(-,root,root)
/%{image_install_path}/vmlinuz-%{KVERREL}-smp-debug
%ifnarch ppc64
/%{image_install_path}/vmlinux-%{KVERREL}-smp-debug
%endif
/boot/System.map-%{KVERREL}-smp-debug
%dir /lib/modules/%{KVERREL}-smp-debug
/lib/modules/%{KVERREL}-smp-debug/kernel
%verify(not mtime) /lib/modules/%{KVERREL}-smp-debug/build
%endif


### --------------- ENTERPRISE---------------------

%if %{buildenterprise} && %{buildnormal}
%files enterprise
%defattr(-,root,root)
/%{image_install_path}/vmlinuz-%{KVERREL}-enterprise
%ifnarch ppc64
/%{image_install_path}/vmlinux-%{KVERREL}-enterprise
%endif
/boot/System.map-%{KVERREL}-enterprise
%dir /lib/modules/%{KVERREL}-enterprise
/lib/modules/%{KVERREL}-enterprise/kernel
%verify(not mtime) /lib/modules/%{KVERREL}-enterprise/build
%endif

%if %{buildenterprise} && %{builddebug}
%files enterprise-debug
%defattr(-,root,root)
/%{image_install_path}/vmlinuz-%{KVERREL}-enterprise-debug
%ifnarch ppc64
/%{image_install_path}/vmlinux-%{KVERREL}-enterprise-debug
%endif
/boot/System.map-%{KVERREL}-enterprise-debug
%dir /lib/modules/%{KVERREL}-enterprise-debug
/lib/modules/%{KVERREL}-enterprise-debug/kernel
%verify(not mtime) /lib/modules/%{KVERREL}-enterprise-debug/build
%endif


### --------------- ENTNOSPLIT ---------------------

%if %{buildentnosplit} && %{buildnormal}
%files entnosplit
%defattr(-,root,root)
/%{image_install_path}/vmlinuz-%{KVERREL}-entnosplit
/%{image_install_path}/vmlinux-%{KVERREL}-entnosplit
/boot/System.map-%{KVERREL}-entnosplit
%dir /lib/modules/%{KVERREL}-entnosplit
/lib/modules/%{KVERREL}-entnosplit/kernel
%verify(not mtime) /lib/modules/%{KVERREL}-entnosplit/build
%endif

%if %{buildentnosplit} && %{builddebug}
%files entnosplit-debug
%defattr(-,root,root)
/%{image_install_path}/vmlinuz-%{KVERREL}-entnosplit-debug
/%{image_install_path}/vmlinux-%{KVERREL}-entnosplit-debug
/boot/System.map-%{KVERREL}-entnosplit-debug
%dir /lib/modules/%{KVERREL}-entnosplit-debug
/lib/modules/%{KVERREL}-entnosplit-debug/kernel
%verify(not mtime) /lib/modules/%{KVERREL}-entnosplit-debug/build
%endif
